package core.notevault.data;

import android.content.Context;
import androidx.room.*;
import core.notevault.data.sync.SyncResponse;
import core.notevault.data.sync.SyncStatusConverter;

@Database(entities = {MusicNote.class, NoteSheet.class, Concert.class, ConcertSong.class, SyncResponse.class}, version = 2, exportSchema = false)
@TypeConverters(DateConverter.class)
public abstract class MusicDatabase extends RoomDatabase {
    public abstract MusicNoteDAO musicNoteDao();

    private static MusicDatabase INSTANCE;

    public static MusicDatabase getDatabase(final Context context) {
        if (INSTANCE == null) {
            synchronized (MusicDatabase.class) {
                if (INSTANCE == null) {
                    INSTANCE = Room.databaseBuilder(context.getApplicationContext(),
                                    MusicDatabase.class, "music_database")
                            .build();
                }
            }
        }
        return INSTANCE;
    }
}
